
public class Slider extends Widget {

	private int minValue, maxValue, currentValue;

	public Slider() {
		super();
		setMinValue(0);
		setMaxValue(0);
		setCurrentValue(0);

	}

	public Slider(int xPosition, int yPosition, int minValue, int maxValue) {
		super(xPosition, yPosition);
		this.minValue = minValue;
		this.maxValue = maxValue;
		this.currentValue = minValue;
		adjustValues();
	}

	public int getMinValue() {
		return minValue;
	}

	public void setMinValue(int minValue) {
		this.minValue = minValue;
		adjustValues();
	}

	public int getMaxValue() {
		return maxValue;
	}

	public void setMaxValue(int maxValue) {
		this.maxValue = maxValue;
		adjustValues();
	}

	public int getCurrentValue() {
		return currentValue;
	}

	private void setCurrentValue(int currentValue) {
		this.currentValue = currentValue;
		adjustValues();
	}

	private void adjustValues() {
		if (this.minValue > this.maxValue) {
			this.minValue = this.maxValue;
		}

		if (this.currentValue < this.minValue) {
			this.currentValue = this.minValue;
		} else if (this.currentValue > this.maxValue) {
			this.currentValue = this.maxValue;
		}
	}

	public void slideTo(int newValue) {
		setCurrentValue(newValue);
	}

	@Override
	public void interact() {
		slideTo(getCurrentValue() + 1);
	}

	@Override
	public String toString() {
		return super.toString() + ", " + printState();
	}

	public String printState() {
		return "minimalna pozicija: " + getMinValue() + ", maksimalna pozicija: " + getMaxValue()
				+ " i trenutna vrijednost: " + getCurrentValue();
	}

}
